# DO NOT EDIT! This file was auto-generated by crates/build/re_types_builder/src/codegen/python/mod.rs
# Based on "crates/store/re_types/definitions/rerun/blueprint/archetypes/dataframe_query.fbs".

# You can extend this class by creating a "DataframeQueryExt" class in "dataframe_query_ext.py".

from __future__ import annotations

from attrs import define, field

from ... import datatypes
from ..._baseclasses import (
    Archetype,
)
from ...blueprint import components as blueprint_components, datatypes as blueprint_datatypes
from ...error_utils import catch_and_log_exceptions
from .dataframe_query_ext import DataframeQueryExt

__all__ = ["DataframeQuery"]


@define(str=False, repr=False, init=False)
class DataframeQuery(DataframeQueryExt, Archetype):
    """
    **Archetype**: The query for the dataframe view.

    ⚠️ **This type is _unstable_ and may change significantly in a way that the data won't be backwards compatible.**
    """

    # __init__ can be found in dataframe_query_ext.py

    def __attrs_clear__(self) -> None:
        """Convenience method for calling `__attrs_init__` with all `None`s."""
        self.__attrs_init__(
            timeline=None,
            filter_by_range=None,
            filter_is_not_null=None,
            apply_latest_at=None,
            select=None,
        )

    @classmethod
    def _clear(cls) -> DataframeQuery:
        """Produce an empty DataframeQuery, bypassing `__init__`."""
        inst = cls.__new__(cls)
        inst.__attrs_clear__()
        return inst

    @classmethod
    def from_fields(
        cls,
        *,
        clear_unset: bool = False,
        timeline: datatypes.Utf8Like | None = None,
        filter_by_range: blueprint_datatypes.FilterByRangeLike | None = None,
        filter_is_not_null: blueprint_datatypes.FilterIsNotNullLike | None = None,
        apply_latest_at: datatypes.BoolLike | None = None,
        select: blueprint_datatypes.SelectedColumnsLike | None = None,
    ) -> DataframeQuery:
        """
        Update only some specific fields of a `DataframeQuery`.

        Parameters
        ----------
        clear_unset:
            If true, all unspecified fields will be explicitly cleared.
        timeline:
            The timeline for this query.

            If unset, the timeline currently active on the time panel is used.
        filter_by_range:
            If provided, only rows whose timestamp is within this range will be shown.

            Note: will be unset as soon as `timeline` is changed.
        filter_is_not_null:
            If provided, only show rows which contains a logged event for the specified component.
        apply_latest_at:
            Should empty cells be filled with latest-at queries?
        select:
            Selected columns. If unset, all columns are selected.

        """

        inst = cls.__new__(cls)
        with catch_and_log_exceptions(context=cls.__name__):
            kwargs = {
                "timeline": timeline,
                "filter_by_range": filter_by_range,
                "filter_is_not_null": filter_is_not_null,
                "apply_latest_at": apply_latest_at,
                "select": select,
            }

            if clear_unset:
                kwargs = {k: v if v is not None else [] for k, v in kwargs.items()}  # type: ignore[misc]

            inst.__attrs_init__(**kwargs)
            return inst

        inst.__attrs_clear__()
        return inst

    @classmethod
    def cleared(cls) -> DataframeQuery:
        """Clear all the fields of a `DataframeQuery`."""
        return cls.from_fields(clear_unset=True)

    timeline: blueprint_components.TimelineNameBatch | None = field(
        metadata={"component": True},
        default=None,
        converter=blueprint_components.TimelineNameBatch._converter,  # type: ignore[misc]
    )
    # The timeline for this query.
    #
    # If unset, the timeline currently active on the time panel is used.
    #
    # (Docstring intentionally commented out to hide this field from the docs)

    filter_by_range: blueprint_components.FilterByRangeBatch | None = field(
        metadata={"component": True},
        default=None,
        converter=blueprint_components.FilterByRangeBatch._converter,  # type: ignore[misc]
    )
    # If provided, only rows whose timestamp is within this range will be shown.
    #
    # Note: will be unset as soon as `timeline` is changed.
    #
    # (Docstring intentionally commented out to hide this field from the docs)

    filter_is_not_null: blueprint_components.FilterIsNotNullBatch | None = field(
        metadata={"component": True},
        default=None,
        converter=blueprint_components.FilterIsNotNullBatch._converter,  # type: ignore[misc]
    )
    # If provided, only show rows which contains a logged event for the specified component.
    #
    # (Docstring intentionally commented out to hide this field from the docs)

    apply_latest_at: blueprint_components.ApplyLatestAtBatch | None = field(
        metadata={"component": True},
        default=None,
        converter=blueprint_components.ApplyLatestAtBatch._converter,  # type: ignore[misc]
    )
    # Should empty cells be filled with latest-at queries?
    #
    # (Docstring intentionally commented out to hide this field from the docs)

    select: blueprint_components.SelectedColumnsBatch | None = field(
        metadata={"component": True},
        default=None,
        converter=blueprint_components.SelectedColumnsBatch._converter,  # type: ignore[misc]
    )
    # Selected columns. If unset, all columns are selected.
    #
    # (Docstring intentionally commented out to hide this field from the docs)

    __str__ = Archetype.__str__
    __repr__ = Archetype.__repr__  # type: ignore[assignment]
