# DO NOT EDIT! This file was auto-generated by crates/build/re_types_builder/src/codegen/python/mod.rs
# Based on "crates/store/re_types/definitions/rerun/blueprint/archetypes/scalar_axis.fbs".

# You can extend this class by creating a "ScalarAxisExt" class in "scalar_axis_ext.py".

from __future__ import annotations

from typing import Any

from attrs import define, field

from ... import components, datatypes
from ..._baseclasses import (
    Archetype,
)
from ...blueprint import components as blueprint_components
from ...error_utils import catch_and_log_exceptions

__all__ = ["ScalarAxis"]


@define(str=False, repr=False, init=False)
class ScalarAxis(Archetype):
    """
    **Archetype**: Configuration for the scalar axis of a plot.

    ⚠️ **This type is _unstable_ and may change significantly in a way that the data won't be backwards compatible.**
    """

    def __init__(
        self: Any, *, range: datatypes.Range1DLike | None = None, zoom_lock: datatypes.BoolLike | None = None
    ) -> None:
        """
        Create a new instance of the ScalarAxis archetype.

        Parameters
        ----------
        range:
            The range of the axis.

            If unset, the range well be automatically determined based on the queried data.
        zoom_lock:
            If enabled, the Y axis range will remain locked to the specified range when zooming.

        """

        # You can define your own __init__ function as a member of ScalarAxisExt in scalar_axis_ext.py
        with catch_and_log_exceptions(context=self.__class__.__name__):
            self.__attrs_init__(range=range, zoom_lock=zoom_lock)
            return
        self.__attrs_clear__()

    def __attrs_clear__(self) -> None:
        """Convenience method for calling `__attrs_init__` with all `None`s."""
        self.__attrs_init__(
            range=None,
            zoom_lock=None,
        )

    @classmethod
    def _clear(cls) -> ScalarAxis:
        """Produce an empty ScalarAxis, bypassing `__init__`."""
        inst = cls.__new__(cls)
        inst.__attrs_clear__()
        return inst

    @classmethod
    def from_fields(
        cls,
        *,
        clear_unset: bool = False,
        range: datatypes.Range1DLike | None = None,
        zoom_lock: datatypes.BoolLike | None = None,
    ) -> ScalarAxis:
        """
        Update only some specific fields of a `ScalarAxis`.

        Parameters
        ----------
        clear_unset:
            If true, all unspecified fields will be explicitly cleared.
        range:
            The range of the axis.

            If unset, the range well be automatically determined based on the queried data.
        zoom_lock:
            If enabled, the Y axis range will remain locked to the specified range when zooming.

        """

        inst = cls.__new__(cls)
        with catch_and_log_exceptions(context=cls.__name__):
            kwargs = {
                "range": range,
                "zoom_lock": zoom_lock,
            }

            if clear_unset:
                kwargs = {k: v if v is not None else [] for k, v in kwargs.items()}  # type: ignore[misc]

            inst.__attrs_init__(**kwargs)
            return inst

        inst.__attrs_clear__()
        return inst

    @classmethod
    def cleared(cls) -> ScalarAxis:
        """Clear all the fields of a `ScalarAxis`."""
        return cls.from_fields(clear_unset=True)

    range: components.Range1DBatch | None = field(
        metadata={"component": True},
        default=None,
        converter=components.Range1DBatch._converter,  # type: ignore[misc]
    )
    # The range of the axis.
    #
    # If unset, the range well be automatically determined based on the queried data.
    #
    # (Docstring intentionally commented out to hide this field from the docs)

    zoom_lock: blueprint_components.LockRangeDuringZoomBatch | None = field(
        metadata={"component": True},
        default=None,
        converter=blueprint_components.LockRangeDuringZoomBatch._converter,  # type: ignore[misc]
    )
    # If enabled, the Y axis range will remain locked to the specified range when zooming.
    #
    # (Docstring intentionally commented out to hide this field from the docs)

    __str__ = Archetype.__str__
    __repr__ = Archetype.__repr__  # type: ignore[assignment]
