# DO NOT EDIT! This file was auto-generated by crates/build/re_types_builder/src/codegen/python/mod.rs
# Based on "crates/store/re_types/definitions/rerun/datatypes/vec3d.fbs".

# You can extend this class by creating a "Vec3DExt" class in "vec3d_ext.py".

from __future__ import annotations

from collections.abc import Sequence
from typing import TYPE_CHECKING, Any, Union

import numpy as np
import numpy.typing as npt
import pyarrow as pa
from attrs import define, field

from .._baseclasses import (
    BaseBatch,
)
from .._converters import (
    to_np_float32,
)
from .vec3d_ext import Vec3DExt

__all__ = ["Vec3D", "Vec3DArrayLike", "Vec3DBatch", "Vec3DLike"]


@define(init=False)
class Vec3D(Vec3DExt):
    """**Datatype**: A vector in 3D space."""

    def __init__(self: Any, xyz: Vec3DLike) -> None:
        """Create a new instance of the Vec3D datatype."""

        # You can define your own __init__ function as a member of Vec3DExt in vec3d_ext.py
        self.__attrs_init__(xyz=xyz)

    xyz: npt.NDArray[np.float32] = field(converter=to_np_float32)

    def __array__(self, dtype: npt.DTypeLike = None, copy: bool | None = None) -> npt.NDArray[Any]:
        # You can define your own __array__ function as a member of Vec3DExt in vec3d_ext.py
        return np.asarray(self.xyz, dtype=dtype, copy=copy)


if TYPE_CHECKING:
    Vec3DLike = Union[Vec3D, npt.NDArray[Any], npt.ArrayLike, Sequence[float]]
else:
    Vec3DLike = Any

Vec3DArrayLike = Union[
    Vec3D, Sequence[Vec3DLike], npt.NDArray[Any], npt.ArrayLike, Sequence[Sequence[float]], Sequence[float]
]


class Vec3DBatch(BaseBatch[Vec3DArrayLike]):
    _ARROW_DATATYPE = pa.list_(pa.field("item", pa.float32(), nullable=False, metadata={}), 3)

    @staticmethod
    def _native_to_pa_array(data: Vec3DArrayLike, data_type: pa.DataType) -> pa.Array:
        return Vec3DExt.native_to_pa_array_override(data, data_type)
